#!/usr/bin/perl

print "Enter The OpenCA dir ( /usr/local/OpenCA ) ? ";
$OPENCA_DIR = <STDIN>;
chop($OPENCA_DIR);

if( "$OPENCA_DIR" eq "" ) {
	$OPENCA_DIR = '/usr/local/OpenCA';
}

print "Enter The Certificate Dir ( $OPENCA_DIR/certs/new ) ? ";
$CERTS_DIR = <STDIN>;
chop($CERTS_DIR);

if( "$CERTS_DIR" eq "" ) {
	$CERTS_DIR = "$OPENCA_DIR/certs/new";
}

print "Enter The ssl dir ( /usr/local/ssl ) ? ";
$SSL_DIR = <STDIN>;
chop($SSL_DIR);

if( "$SSL_DIR" eq "" ) {
	$SSL_DIR = "/usr/local/ssl";
}

## $DBM_FILE = "$OPENCA_DIR/stuff/issued_certs";
$DBM_FILE = "$OPENCA_DIR/stuff/archivied_reqs";
$STATUS_FILE = "$OPENCA_DIR/stuff/revoked_certs";

opendir ( DIR , "$CERTS_DIR" );
	@certs = grep(/pem/, readdir( DIR ) );
closedir( DIR );


foreach $file ( @certs ) {
	print "Adding certificate ";

	$info = `$SSL_DIR/bin/openssl x509 -text -noout <$CERTS_DIR/$file`;

	next if ( $info =~ /error/i );

	( $serial ) =
		( $info =~ /Serial Number:[^x]*.([^\)]+)/i );

	( $notBefore ) =
	 	( $info =~ /Not Before: ([^\n]+)/i );

	( $notAfter ) =
		( $info =~ /Not after : ([^\n]+)/i );

	if ( length( $serial ) < 2 ) {
	 	$serial = "0" . uc($serial);
	}

	print ": ( $serial )\n";
	print "      Not Before: $notBefore\n";
	print "      Not After : $notAfter\n";
	
	$fileName = "$CERTS_DIR/$file";
	$cert = "";
	open( FD, "$fileName" ) or die "Can't access $fileName\n\n";
		while( $tmp = <FD> ) {
			next if ( ($cert eq "") and ($tmp !~ /BEGIN CERTIFICATE/ ));
			$cert .= $tmp;
		}
	close( FD );

	## print "$cert\n";

	dbmopen( %CERT_DB, "$DBM_FILE", 0600 ) || die "Can't access DB!";
		## $CERT_DB{$serial} = "$cert";
	dbmclose( %CERT_DB );

	print "Ok.\n";
}

exit;
